#property copyright "Copyright c 2006, Cyberia Decisions"
#property link      "http://cyberia.org.ru"

#define DECISION_BUY 1
#define DECISION_SELL 0
#define DECISION_UNKNOWN -1

input string inf0 = "Account lots as percent of funds";
extern double AccountRiskPercent = 1;
input string inf1 = "main adjustable for testings";
extern double BarsCountMax = 23;
input string inf2 = "0 = auto, else points";
extern double StaticStopLoss = 0;
input string inf3 = "with prev auto this is auto-changed";
extern double StopLossIndex = 1.1;
input string inf4 = "Test reverse signals";
input bool EnableReverceDetector = false;
input double ReverceIndex = 3;
input string inf5 = "Main version for trades";
input bool EnableCyberiaLogic = true;
input bool EnableLogicTrading = true;
input string inf6 = "Another version for trades";
input bool EnableMoneyTrain = false;
input double MoneyTrainLevel = 4;
input string inf7 = "Another version for trades";
extern bool BlockPipsator = true;
input string inf8 = "Filters to be included";
input bool EnableMACD = false;
input int MACDLevel = 10;
input bool EnableADX = false;
input bool EnableMA = false;
input bool EnableFractals = false;
input bool EnableCCI = false;

bool MarketExit = false;

double StopLoss = 0;
double TakeProfit = 0;
double StopLevel;
bool DisableExitSell = false;
bool DisableExitBuy = false;
bool BlockSell = false;
bool BlockBuy = false;
double ValuesPeriodCount;
double Lots;
bool DisableSell = false;
bool DisableBuy = false;
bool ExitSell = false;
bool ExitBuy = false;
bool PartClosed;
double Disperce = 0;
double DisperceMax = 0;
bool DisableSellPipsator = false;
bool DisableBuyPipsator = false;
//----
int ValuePeriod = 1;
int ValuePeriodPrev = 1;
int FoundOpenedOrder;
bool DisablePipsator = false;
double BidPrev = 0;
double AskPrev = 0;

double BuyPossibilityQuality;
double SellPossibilityQuality;
double UndefinedPossibilityQuality;
//double BuyPossibilityQualityMid;
double PossibilityQuality;
double QualityMax = 0;
//----
double BuySucPossibilityQuality;
double SellSucPossibilityQuality;
double UndefinedSucPossibilityQuality;
double PossibilitySucQuality;
//----
double ModelingPeriod;
double ModelingBars;
//----
double Spread;
int Decision;
double DecisionValue;
double PrevDecisionValue;
//----
int ticket, total, cnt;
//----
double BuyPossibility;
double SellPossibility;
double UndefinedPossibility;
double BuyPossibilityPrev;
double SellPossibilityPrev;
double UndefinedPossibilityPrev;
//----
double BuySucPossibilityMid;
double SellSucPossibilityMid;
double UndefinedSucPossibilityMid;
//----
double SellSucPossibilityCount;
double BuySucPossibilityCount;
double UndefinedSucPossibilityCount;
//----
double BuyPossibilityMid;
double SellPossibilityMid;
double UndefinedPossibilityMid;
//----
double SellPossibilityCount;
double BuyPossibilityCount;
double UndefinedPossibilityCount;
double ModeLow;
double ModeHigh;
double ModeTime;
double ModeBid;
double ModeAsk;
double ModePoint;
double ModeDigits;
double ModeSpread;
double ModeStopLevel;
double ModeLotSize;
double ModeTickValue;
double ModeTickSize;
double ModeSwapLong;
double ModeSwapShort;
double ModeStarting;
double ModeExpiration;
double ModeTradeAllowed;
double ModeMinLot;
double ModeLotStep;
int digits_convert=1;
string sym;
datetime time_bar=0;
/********************************************************************/
/********************************************************************/
int init()  {
   sym=sym;
   if(Digits==5 || Digits==3 || Digits==1) digits_convert=10;
   ValuesPeriodCount = BarsCountMax;
   reset();
   return(0);
  }
/********************************************************************/
/********************************************************************/
void start() {
   GetMarketInfo();
   FindSuitablePeriod();
   CyberiaDecision();
   Trade();
   SaveStat();
   return; }
/********************************************************************/
/********************************************************************/
void GetMarketInfo()  {
   ModeLow = MarketInfo(sym, MODE_LOW);
   ModeHigh = MarketInfo(sym, MODE_HIGH);
   ModeTime = MarketInfo(sym, MODE_TIME);
   ModeBid = MarketInfo(sym, MODE_BID);
   ModeAsk = MarketInfo(sym, MODE_ASK);
   ModePoint = MarketInfo(sym, MODE_POINT);
   ModeDigits = MarketInfo(sym, MODE_DIGITS);
   ModeSpread = MarketInfo(sym, MODE_SPREAD);
   ModeStopLevel = MarketInfo(sym, MODE_STOPLEVEL);
   ModeLotSize = MarketInfo(sym, MODE_LOTSIZE);
   ModeTickValue = MarketInfo(sym, MODE_TICKVALUE);
   ModeTickSize = MarketInfo(sym, MODE_TICKSIZE);
   ModeSwapLong = MarketInfo(sym, MODE_SWAPLONG);
   ModeSwapShort = MarketInfo(sym, MODE_SWAPSHORT);
   ModeStarting = MarketInfo(sym, MODE_STARTING);
   ModeExpiration = MarketInfo(sym, MODE_EXPIRATION);
   ModeTradeAllowed = MarketInfo(sym, MODE_TRADEALLOWED);
   ModeMinLot = MarketInfo(sym, MODE_MINLOT);
   ModeLotStep = MarketInfo(sym, MODE_LOTSTEP);
   Spread = ModeSpread * ModePoint;
   return;  }
/********************************************************************/
/********************************************************************/
double CyberiaLots()  {
   if(AccountRiskPercent<=0) return(MarketInfo(sym,MODE_MINLOT));
   return(PartLot(Dev(AccountFreeMargin(),MarketInfo(sym,32))*0.01*AccountRiskPercent));
}
/********************************************************************/
double PartLot( double plot ) {
   int rounded=plot/MarketInfo(sym,MODE_LOTSTEP);
   return(MathMax(MarketInfo(sym,MODE_MINLOT),MathMin(rounded*MarketInfo(sym,MODE_LOTSTEP),MarketInfo(sym,MODE_MAXLOT))));
}
/********************************************************************/
/********************************************************************/
void reset()  {
   ModelingPeriod = ValuePeriod * BarsCountMax; 
   if (ValuePeriod != 0 ) ModelingBars = ModelingPeriod / ValuePeriod; 
   return;
  }
/********************************************************************/
/********************************************************************/
int CalculatePossibility (int shift)  {
   DecisionValue = iClose( sym, 0, ValuePeriod * shift) - iOpen( sym, 0, ValuePeriod * shift);
   PrevDecisionValue = iClose( sym, 0, ValuePeriod * (shift+1)) - iOpen( sym, 0, ValuePeriod * (shift+1));
   SellPossibility = 0;
   BuyPossibility = 0;
   UndefinedPossibility = 0;
   if(DecisionValue != 0)  {
     if(DecisionValue > 0)  {
       if(PrevDecisionValue < 0) {
         Decision = DECISION_SELL;
         BuyPossibility = 0;
         SellPossibility = DecisionValue;
         UndefinedPossibility = 0;
       }
       else {
         Decision = DECISION_UNKNOWN;
         UndefinedPossibility = DecisionValue;
         BuyPossibility = 0;
         SellPossibility = 0;
       }
     }
     else {
       if(PrevDecisionValue > 0) {
         Decision = DECISION_BUY;
         SellPossibility = 0;
         UndefinedPossibility = 0;
         BuyPossibility = -1 * DecisionValue;
       }
       else {
         Decision = DECISION_UNKNOWN;
         UndefinedPossibility = -1 * DecisionValue;
         SellPossibility = 0;
         BuyPossibility = 0;
       }
     }
   }
   else {
     Decision = DECISION_UNKNOWN;
     UndefinedPossibility = 0;
     SellPossibility = 0;
     BuyPossibility = 0;
   }
   return (Decision);  }
/********************************************************************/
/********************************************************************/
int CalculatePossibilityStat()  {
   int i;
   BuySucPossibilityCount = 0;
   SellSucPossibilityCount = 0;
   UndefinedSucPossibilityCount = 0;

   BuyPossibilityCount = 0;
   SellPossibilityCount = 0;
   UndefinedPossibilityCount = 0;

   BuySucPossibilityMid = 0;
   SellSucPossibilityMid = 0;
   UndefinedSucPossibilityMid = 0;
   BuyPossibilityQuality = 0;
   SellPossibilityQuality = 0;
   UndefinedPossibilityQuality = 0;
   PossibilityQuality = 0;

   BuySucPossibilityQuality = 0;
   SellSucPossibilityQuality = 0;
   UndefinedSucPossibilityQuality = 0;
   PossibilitySucQuality = 0;
   for( i = 0 ; i < ModelingBars ; i ++ )
     {
       CalculatePossibility (i);
       if(Decision == DECISION_SELL ) SellPossibilityQuality ++;
       if(Decision == DECISION_BUY ) BuyPossibilityQuality ++;
       if(Decision == DECISION_UNKNOWN ) UndefinedPossibilityQuality ++;               
       if((BuyPossibility > Spread) || (SellPossibility > Spread) || (UndefinedPossibility > Spread)) {
         if(Decision == DECISION_SELL) SellSucPossibilityQuality ++;                     
         if(Decision == DECISION_BUY) BuySucPossibilityQuality ++;
         if(Decision == DECISION_UNKNOWN ) UndefinedSucPossibilityQuality ++;                   
       }
       BuyPossibilityMid *= BuyPossibilityCount;
       BuyPossibilityCount ++;
       BuyPossibilityMid += BuyPossibility;
       if(BuyPossibilityCount != 0 ) BuyPossibilityMid /= BuyPossibilityCount;
       else BuyPossibilityMid = 0;
       SellPossibilityMid *= SellPossibilityCount;
       SellPossibilityCount ++;
       SellPossibilityMid += SellPossibility;
       if(SellPossibilityCount != 0 ) SellPossibilityMid /= SellPossibilityCount;
       else SellPossibilityMid = 0;
       UndefinedPossibilityMid *= UndefinedPossibilityCount;
       UndefinedPossibilityCount ++;
       UndefinedPossibilityMid += UndefinedPossibility;
       if(UndefinedPossibilityCount != 0) UndefinedPossibilityMid /= UndefinedPossibilityCount;
       else UndefinedPossibilityMid = 0;
       if(BuyPossibility > Spread) {
         BuySucPossibilityMid *= BuySucPossibilityCount;
         BuySucPossibilityCount ++;
         BuySucPossibilityMid += BuyPossibility;
         if(BuySucPossibilityCount != 0) BuySucPossibilityMid /= BuySucPossibilityCount;
         else BuySucPossibilityMid = 0;
       }
       if(SellPossibility > Spread) {
         SellSucPossibilityMid *= SellSucPossibilityCount;
         SellSucPossibilityCount ++;                 
         SellSucPossibilityMid += SellPossibility;
         if (SellSucPossibilityCount != 0) SellSucPossibilityMid /= SellSucPossibilityCount;
         else SellSucPossibilityMid = 0;
       }
       if(UndefinedPossibility > Spread) {
         UndefinedSucPossibilityMid *= UndefinedSucPossibilityCount;
         UndefinedSucPossibilityCount ++;                 
         UndefinedSucPossibilityMid += UndefinedPossibility;
         if(UndefinedSucPossibilityCount != 0) UndefinedSucPossibilityMid /= UndefinedSucPossibilityCount;
         else UndefinedSucPossibilityMid = 0;
       }
     }
   if((UndefinedPossibilityQuality + SellPossibilityQuality + BuyPossibilityQuality) != 0)
     PossibilityQuality = (SellPossibilityQuality + BuyPossibilityQuality) / (UndefinedPossibilityQuality + SellPossibilityQuality + BuyPossibilityQuality);
   else PossibilityQuality = 0;
   if((UndefinedSucPossibilityQuality + SellSucPossibilityQuality + BuySucPossibilityQuality)!= 0)          
     PossibilitySucQuality = (SellSucPossibilityQuality + BuySucPossibilityQuality) / (UndefinedSucPossibilityQuality + SellSucPossibilityQuality + BuySucPossibilityQuality);
   else PossibilitySucQuality = 0;
   return(0); }
/********************************************************************/
/********************************************************************/
void DisplayStat()  {

  }
/********************************************************************/
/********************************************************************/
int CyberiaDecision()  {
   CalculatePossibilityStat();
   CalculatePossibility(0);
   DisplayStat();
   return(Decision);  }
/********************************************************************/
/********************************************************************/
void CalculateDirection()  {
   DisableSellPipsator = false;
   DisableBuyPipsator = false;
   DisablePipsator = false;
   DisableSell = false;
   DisableBuy = false;
   DisableExitSell = false;
   DisableExitBuy = false;

   if(EnableCyberiaLogic) AskCyberiaLogic();
   if(EnableMACD) AskMACD();
   if(EnableMA) AskMA();
   if(EnableFractals) AskFractals();
   if(EnableCCI) AskCCI();
   if(EnableADX) AskADX();
   if(EnableReverceDetector) ReverceDetector();
   return;  }
/********************************************************************/
/********************************************************************/
void AskADX ()   {
   if ( iADX(NULL,0,14,PRICE_HIGH,MODE_PLUSDI,0)>iADX(NULL,0,14,PRICE_HIGH,MODE_MINUSDI,0) ) DisableSell = true;
   if ( iADX(NULL,0,14,PRICE_HIGH,MODE_PLUSDI,0)<iADX(NULL,0,14,PRICE_HIGH,MODE_MINUSDI,0) ) DisableBuy= true;
   return; }
/********************************************************************/
/********************************************************************/
void AskCCI ()  {
   if (iCCI( NULL, 0, 13, PRICE_TYPICAL, 0) < -100) DisableSell = true;
   if (iCCI( NULL, 0, 13, PRICE_TYPICAL, 0) > 1000) DisableBuy = true;
   return; }
/********************************************************************/
/********************************************************************/
void AskFractals ()   {
   int i = 0;
   while (iFractals( NULL, 0, MODE_UPPER, i ) == 0  && iFractals( NULL, 0, MODE_LOWER, i ) == 0) i ++;
   if (iFractals( NULL, 0, MODE_UPPER, i ) != 0 ) { BlockBuy = true; BlockSell = false; }
   if (iFractals( NULL, 0, MODE_LOWER, i ) != 0 ) { BlockSell = true; BlockBuy = false; }
   return;  }
/********************************************************************/
/********************************************************************/
void ReverceDetector()  {
   if((BuyPossibility > BuyPossibilityMid * ReverceIndex && BuyPossibility != 0 && BuyPossibilityMid != 0) || (SellPossibility > SellPossibilityMid * ReverceIndex && SellPossibility != 0 && SellPossibilityMid != 0)) {
     DisableSell = (!DisableSell);
     DisableBuy = (!DisableBuy);
     DisableSellPipsator = (!DisableSellPipsator);
     DisableBuyPipsator = (!DisableBuyPipsator);
   }
   return;  }
/********************************************************************/
/********************************************************************/
void AskCyberiaLogic()  {
   /* DisableBuy = true; DisableSell = true; DisablePipsator = false; */
   if(ValuePeriod > ValuePeriodPrev) {
     if(SellPossibilityMid*SellPossibilityQuality > BuyPossibilityMid*BuyPossibilityQuality) {
       DisableBuy = true;
       DisableBuyPipsator = true;
       if(SellSucPossibilityMid*SellSucPossibilityQuality > BuySucPossibilityMid*BuySucPossibilityQuality) DisableSell = true;
       else DisableSell = false;
     }
     if(SellPossibilityMid*SellPossibilityQuality < BuyPossibilityMid*BuyPossibilityQuality) {
       DisableSell = true;
       DisableSellPipsator = true;
       if(SellSucPossibilityMid*SellSucPossibilityQuality < BuySucPossibilityMid*BuySucPossibilityQuality) DisableBuy = true;
       else DisableBuy = false;
     }
   }
   if(ValuePeriod < ValuePeriodPrev) {
     if(SellPossibilityMid*SellPossibilityQuality > BuyPossibilityMid*BuyPossibilityQuality)
       { DisableSell = true; DisableBuy = true; }
     if(SellPossibilityMid*SellPossibilityQuality < BuyPossibilityMid*BuyPossibilityQuality)
       { DisableSell = true; DisableBuy = true; }
   }
   if(SellPossibilityMid*SellPossibilityQuality == BuyPossibilityMid*BuyPossibilityQuality)
     { DisableSell = true; DisableBuy = true; DisablePipsator=false; }
   if(SellPossibility > SellSucPossibilityMid * 2 && SellSucPossibilityMid > 0)
     { DisableSell = true; DisableSellPipsator = true; }
   if(BuyPossibility > BuySucPossibilityMid * 2 && BuySucPossibilityMid > 0 )
   { DisableBuy = true; DisableBuyPipsator = true; }
   return; }
/********************************************************************/
/********************************************************************/
void AskMA()  {
   if(iMA(sym, 0, ValuePeriod, 0 , MODE_EMA, PRICE_CLOSE, 0) > iMA(sym, 0, ValuePeriod, 0 , MODE_EMA, PRICE_CLOSE, 1))
     { DisableSell = true; DisableSellPipsator = true; }
   if(iMA(sym, 0, ValuePeriod, 0 , MODE_EMA, PRICE_CLOSE, 0) < iMA(sym, 0, ValuePeriod, 0 , MODE_EMA, PRICE_CLOSE, 1))
     { DisableBuy = true; DisableBuyPipsator = true; }
   return;  }
/********************************************************************/
/********************************************************************/
void AskMACD()  {
   double SellIndex = 0;
   double BuyIndex = 0;
   for(int i = 0 ; i < MACDLevel ; i ++) {
     if(iMACD(sym, MathPow( 2, i) , 2, 4, 1, PRICE_CLOSE, MODE_MAIN, 0) < 
        iMACD(sym, MathPow( 2, i), 2, 4, 1, PRICE_CLOSE, MODE_MAIN, 1) ) {
       SellIndex += iMACD(sym, MathPow( 2, i), 2, 4, 1, PRICE_CLOSE, MODE_MAIN, 0);
     }
     if(iMACD(sym, MathPow( 2, i), 2, 4, 1, PRICE_CLOSE, MODE_MAIN, 0) > 
        iMACD(sym, MathPow( 2, i), 2, 4, 1, PRICE_CLOSE, MODE_MAIN, 1) ) {
       BuyIndex += iMACD(sym, MathPow( 2, i), 2, 4, 1, PRICE_CLOSE, MODE_MAIN, 0);
     }
   }
   if(SellIndex> BuyIndex) { DisableBuy = true; DisableBuyPipsator = true; }
   if(SellIndex < BuyIndex) { DisableSell = true; DisableSellPipsator = true; }
   return;  }
/********************************************************************/
/********************************************************************/
int SendBuy() {
   Lots = CyberiaLots();
   if(Lots <= 0) return (0);
   if ( StaticStopLoss > 0 ) StopLoss = Bid - MathMax(StaticStopLoss,ModeStopLevel) * Point;
   else {
     int intStopLoss = Dev(MathMax(ModeStopLevel * Point,SellSucPossibilityMid),Point) + MathMax(Point,ModeSpread * Point + Disperce)/Point;
     StopLoss = Bid - intStopLoss * Point;
   }
   return( OrderSend(sym, OP_BUY, Lots, Ask, digits_convert, StopLoss, TakeProfit) ); }
/********************************************************************/
/********************************************************************/
int SendSell() {
   Lots = CyberiaLots();
   if(Lots <= 0) return (0);
   if ( StaticStopLoss > 0 ) StopLoss = Ask + MathMax(StaticStopLoss,ModeStopLevel) * Point;
   else {
     int intStopLoss = Dev(MathMax(ModeStopLevel * Point,BuySucPossibilityMid),Point) + MathMax(Point,ModeSpread * Point + Disperce)/Point;
     StopLoss = Ask + intStopLoss * Point;
   }
   return( OrderSend(sym, OP_SELL, Lots, Bid, digits_convert, StopLoss, TakeProfit) ); }
/********************************************************************/
/********************************************************************/
void MoneyTrain()  {
   if(FindSymbolOrder()) return;
   /* Disperce = (iHigh ( sym, 0, 0) - iLow ( sym, 0, 0)); */
   double spike = Dev(iClose( sym, 0, 0) - iClose( sym, 0, ValuePeriod),MoneyTrainLevel);
   if(Decision == DECISION_SELL && BlockBuy == false)
     if(spike >= SellSucPossibilityMid && SellSucPossibilityMid != 0)
       if(SendBuy()>0)
         { StopLevel = StopLoss; PartClosed = false; return; }
   if(Decision == DECISION_BUY && BlockSell == false)
     if(spike * (-1) >= BuySucPossibilityMid && BuySucPossibilityMid != 0)
       if(SendSell()>0)
         { StopLevel = StopLoss; PartClosed = false; return; }
   return; }
/********************************************************************/
/********************************************************************/
void EnterMarket()  {
   if(FindSymbolOrder()) return;
   if(Decision == DECISION_SELL && BlockSell == false && DisableSell == false)
     if(SellPossibility >= SellSucPossibilityMid)
       if(SendSell() > 0)
         { StopLevel = StopLoss; PartClosed = false; return; }
   if(Decision == DECISION_BUY && BlockBuy == false && DisableBuy == false)
     if(BuyPossibility >= BuySucPossibilityMid)
       if(SendBuy() > 0)
         { StopLevel = StopLoss; PartClosed = false; return; }
   return; }   
/********************************************************************/
/********************************************************************/
void RunPipsator()  {
   if( FindSymbolOrder() ) return;
   int i = 0;
   for(i = 0 ; i < ValuePeriod ; i ++) {
     if(!BlockSell && !DisableSell)
       if((Bid - iClose( sym, 0, i + 1)) > SellSucPossibilityMid * (i + 1) && SellSucPossibilityMid != 0 && DisablePipsator == false && DisableSellPipsator == false)
         if( SendSell() > 0 )
           { StopLevel = StopLoss; PartClosed = false; return; }
     if(!DisableBuy && !BlockBuy) 
       if((iClose(sym, 0, i + 1) - Bid) > BuySucPossibilityMid *(i + 1) && BuySucPossibilityMid != 0 && DisablePipsator == False && DisableBuyPipsator == false)
         if( SendBuy() > 0 )
           { StopLevel = StopLoss; PartClosed = false; return; }
   }         
   return; }
/********************************************************************/
/********************************************************************/
void ExitMarket()  {
   if(OrderType()==OP_BUY) {
     if(DisableExitBuy == true || OrderProfit() <= 0.0) return;
     if( TrailOrder() )
       if( OrderClose(OrderTicket(),PartLot(OrderLots()*0.5),Bid ,digits_convert) )
         { PartClosed = true; return; }
     if((iClose( sym, 0, 0) - iClose( sym, 0, 1)) >= SellSucPossibilityMid * 4 && SellSucPossibilityMid > 0) return;
     if((OrderOpenPrice() < Bid) && (Bid - OrderOpenPrice() >= SellSucPossibilityMid) && (SellSucPossibilityMid > 0) )
       if( TrailOrder() )
         if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Bid , digits_convert) )
           { PartClosed = true; return; }
     if((OrderOpenPrice() < Bid) && (Bid - OrderOpenPrice() >= BuySucPossibilityMid) && (BuySucPossibilityMid > 0) )
       if( TrailOrder() )
         if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Bid , digits_convert) )
           { PartClosed = true; return; }
     if((OrderOpenPrice() < Bid) &&  BuySucPossibilityMid == 0 && SellSucPossibilityMid == 0)
       if( TrailOrder() )
         if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Bid , digits_convert) )
           { PartClosed = true; return; }
   }
   if(OrderType() == OP_SELL) {
     if(DisableExitSell == true || OrderProfit() <= 0.0) return;
     if( TrailOrder() )
       if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Ask , digits_convert) )
         { PartClosed = true; return; }
     if((iClose( sym, 0, 1) - iClose( sym, 0, 0)) >= BuySucPossibilityMid * 4 && BuySucPossibilityMid > 0) return;
     if((OrderOpenPrice() > Ask) && (OrderOpenPrice() - Ask) >= BuySucPossibilityMid && BuySucPossibilityMid > 0)
       if( TrailOrder() )
         if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Ask, digits_convert) )
           { PartClosed = true; return; }
     if(OrderOpenPrice() > Ask && (OrderOpenPrice() - Ask) >= SellSucPossibilityMid && SellSucPossibilityMid > 0)
       if( TrailOrder() )
         if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Ask, digits_convert) )
           { PartClosed = true; return; }
     if(OrderOpenPrice() > Ask &&  BuySucPossibilityMid == 0 && SellSucPossibilityMid == 0)
       if( TrailOrder() )
         if( OrderClose(OrderTicket(), PartLot(OrderLots()*0.5), Ask, digits_convert) )
           { PartClosed = true; return; }
   }
 //  ValuePeriodPrev = ValuePeriod;
   return; }   
/********************************************************************/
/********************************************************************/
int FindSymbolOrder() {
   for(cnt = OrdersTotal()-1; cnt > -1; cnt--) {
     if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) continue;
     if(OrderSymbol() == sym) return(true);
   }
   return(false); }
/********************************************************************/
/********************************************************************/
bool TrailOrder()  {
   if(OrderType()==OP_BUY) {
     if(Bid - ModeStopLevel * Point > OrderStopLoss() && Bid - ModeStopLevel * Point >= OrderOpenPrice())
       if( OrderModify(OrderTicket(),0,Bid-ModeStopLevel*Point,0,0) ) return(true);
   }
   if(OrderType() == OP_SELL) {
     if(Ask + ModeStopLevel * Point < OrderStopLoss() && Ask + ModeStopLevel * Point <= OrderOpenPrice())
       if( OrderModify(OrderTicket(),0,Ask+ModeStopLevel*Point,0,0) ) return(true);
   }
   return(false); }   
/********************************************************************/
/********************************************************************/
void SaveStat()  {
   BidPrev = Bid; AskPrev = Ask; ValuePeriodPrev = ValuePeriod;
   return; }
/********************************************************************/
/********************************************************************/
void FindDisperse() {
   if(time_bar >= Time[5]) return;
   DisperceMax = 0;
   for(int i = 1 ; i < ValuePeriod ; i ++) {
     DisperceMax += (iMA(NULL,0,10,0,0,PRICE_HIGH,i) - iMA(NULL,0,10,0,0,PRICE_LOW,i));
   }
   Disperce = MathMax(Dev(DisperceMax,ValuePeriod-1) * StopLossIndex,ModeStopLevel * Point);
   time_bar = Time[0];
   return; }
/********************************************************************/
/********************************************************************/
int Trade ()  {
   FindDisperse();
   if(StaticStopLoss <= 0) AutoStopLoss();
   CalculateDirection();
   if(EnableMoneyTrain) MoneyTrain();
   if(EnableLogicTrading && !MarketExit) EnterMarket();
   if(!DisablePipsator && !BlockPipsator && !MarketExit) RunPipsator();           
   if(FindSymbolOrder()) {
     if(PartClosed) TrailOrder();
     else ExitMarket();
   }
   return(0); }
/********************************************************************/
/********************************************************************/
int FindSuitablePeriod() {
   double SuitablePeriodQuality = -1 *BarsCountMax*BarsCountMax;
   int SuitablePeriod = 0;
   int i;
   for(i = 0 ; i < BarsCountMax ; i ++ ) {
     ValuePeriod = i + 1; /* bars back check as indicators */
     ValuesPeriodCount = ValuePeriod * 5; 
     reset();           
     CalculatePossibilityStat ();
     if(PossibilitySucQuality > SuitablePeriodQuality) {
       SuitablePeriodQuality = PossibilitySucQuality;
       SuitablePeriod = i + 1;
     }
   }
   ValuePeriod = SuitablePeriod;
   reset();
   return(SuitablePeriod); }
/********************************************************************/
/********************************************************************/
int AutoStopLoss() { StopLossIndex = MathMax(ModeSpread,ModeStopLevel); return(0); }
/********************************************************************/
/********************************************************************/
double Dev( double one, double splitter ) {
   if(one!=0.0 && splitter!=0.0) return(one/splitter);
   return(0); }
/********************************************************************/
/********************************************************************/
